<template lang="pug">
  .root-album
    my-modal(
      @close="close"
      v-if="modal.type == 'lightBox'"
    )
      .lightboxContent(
        :style="{ 'background-image': 'url(' + modal.content.href+ ')' }"
      )
        img(
          :src="modal.content.href"
        )
      .paging
        my-button.prev(
          v-if="modal.content.prev"
          @click="prev"
          type="plane"
          size="small"
        )
          img(src="@/assets/btn_prev.svg" alt="前へ" height="13")
        my-button.next(
          v-if="modal.content.next"
          @click="next"
          type="plane"
          size="small"
        )
          img(src="@/assets/btn_next.svg" alt="前へ" height="13")
      my-button.close_btn(
        @click="close"
        size="small"
        type="primary"
      ) 
        img(src="@/assets/btn_text_close.svg" alt="閉じる" height="11")
    //- modalここまで
    img.title(src='@/assets/title_photo_album.svg' alt="フォトアルバム" height="52")
    //- p(style="margin: 20px 0") userName {{userName}}
    my-photo-table(
      :photos="photos.filter(s => (s.active))"
      :meta="false"
      :openLightBox="openLightBox"
    )
    .fixed_footer
      .fixed_footer__inner
        my-button(
          type="primary"
          size="small"
          @click="push('/top')"
        )
          img(src="@/assets/btn_s_text_top.svg" alt="topへ戻る" height="14")
        my-button(
          type="primary"
          size="small"
          @click="push('/post')"
        )
          img(src="@/assets/btn_s_text_open_post.svg" alt="写真を投稿" height="14")
</template>
<script>
import { mapActions, mapGetters } from 'vuex'
import MyButton from '@/components/atoms/Button'
import MyPhotoTable from '@/components/organisms/PhotoTable'
import MyPhotoShower from '@/components/organisms/PhotoShower'
import MyModal from '@/components/organisms/Modal'
import EXIF from 'exif-js'
import router from '@/router/index'

export default {
  name: 'Top',
  components: {
    MyButton,
    MyPhotoTable,
    MyPhotoShower,
    MyModal
  },
  props: {
    // store
  },
  data() {
    return {
      photoIds: []
    }
  },
  computed: {
    ...mapGetters('Auth', {
      userName: 'userName',
      isApproved: 'isApproved',
      userId: 'userId'
    }),
    ...mapGetters('Top', {
      modal: 'modal'
    }),
    ...mapGetters('Photos', {
      photos: 'getPhotos',
      uploader: 'getUploader'
    })
  },
  created() {
    this.listenOnce()
  },
  methods: {
    ...mapActions('Top', {
      close: 'close',
      openLightBox: 'openLightBox',
      changeLightBox: 'changeLightBox'
    }),
    ...mapActions('Photos', {
      listenOnce: 'listenOnce',
      listen: 'listen',
      upload: 'upload',
      onChangeFile: 'onChangeFile'
    }),
    push(path){
      router.push(path)
    },
    triggerSelect() {
      this.$refs.fileInput.click()
    },
    reset() {
      this.onChangeFile({ type: 'reset' })
    },
    selected(e) {
      const input = {}
      const file = (input.file = e.target.files[0])
      console.log(file)
      EXIF.getData(file, () => {
        input.orientation = file.exifdata.Orientation
      })
      if (!file) {
        input.blob = ''
      }
      if (!file.type.match('image.*')) {
        return
      }
      const reader = new FileReader()
      reader.readAsDataURL(file)
      reader.onload = () => {
        input.blob = reader.result
        this.onChangeFile(input)
      }
    },
    submit() {
      const input = this.uploader.input
      const userdata = {
        userId: this.userId,
        userName: this.userName
      }
      const name = file.name
      this.upload({ input, userdata })
    },
    next() {
      const index = Number(this.modal.content.index) + 1
      const path = this.modal.content.next
      this.changeLightBox({ index, path })
    },
    prev() {
      const index = Number(this.modal.content.index) - 1
      const path = this.modal.content.prev
      this.changeLightBox({ index, path })
    }
  }
}
</script>
<style lang="stylus">
.root-album
  padding-top 40px
  padding-bottom 40px
  .title
    margin-bottom $margin-l
  .lightboxContent
    height: 80%
    width: 100%
    position: relative
    background-size: contain
    background-repeat: no-repeat
    background-position: center
    > img
      width: 100%
      height: 100%
      opacity: 0
  .fixed_footer
    position fixed
    bottom 0
    left 0
    right 0
    padding 10px 0
    background alpha($c-bg, 0.8)
    z-index 100
    .fixed_footer__inner
      margin 0 auto
      display flex
      justify-content space-around
      button
        width 45%
  .close_btn
    margin $margin-m auto 0
    width 180px
    position relative
  .paging
    display flex
    justify-content space-between
</style>
